# SPDX-License-Identifier: GPL-2.0-only OR BSD-2-Clause
%YAML 1.2
---
$id: http://devicetree.org/schemas/iio/adc/rohm,bd79124.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: ROHM BD79124 ADC/GPO

maintainers:
  - Matti Vaittinen <mazziesaccount@gmail.com>

description: |
  The ROHM BD79124 is a 12-bit, 8-channel, SAR ADC. The ADC supports
  an automatic measurement mode, with an alarm interrupt for out-of-window
  measurements. ADC input pins can be also configured as general purpose
  outputs.

properties:
  compatible:
    const: rohm,bd79124

  reg:
    description:
      I2C slave address.
    maxItems: 1

  interrupts:
    maxItems: 1

  gpio-controller: true

  "#gpio-cells":
    const: 1
    description:
      The pin number.

  vdd-supply: true

  iovdd-supply: true

  "#address-cells":
    const: 1

  "#size-cells":
    const: 0

patternProperties:
  "^channel@[0-7]+$":
    type: object
    $ref: /schemas/iio/adc/adc.yaml#
    description: Represents ADC channel.

    properties:
      reg:
        description: AIN pin number
        minimum: 0
        maximum: 7

    required:
      - reg

    additionalProperties: false

required:
  - compatible
  - reg
  - iovdd-supply
  - vdd-supply

additionalProperties: false

examples:
  - |
    #include <dt-bindings/interrupt-controller/irq.h>
    #include <dt-bindings/leds/common.h>
    i2c {
        #address-cells = <1>;
        #size-cells = <0>;
        adc: adc@10 {
            compatible = "rohm,bd79124";
            reg = <0x10>;

            interrupt-parent = <&gpio1>;
            interrupts = <29 IRQ_TYPE_LEVEL_LOW>;

            vdd-supply = <&dummyreg>;
            iovdd-supply = <&dummyreg>;

            #address-cells = <1>;
            #size-cells = <0>;

            channel@0 {
                reg = <0>;
            };
            channel@1 {
                reg = <1>;
            };
            channel@2 {
                reg = <2>;
            };
            channel@3 {
                reg = <3>;
            };
            channel@4 {
                reg = <4>;
            };
            channel@5 {
                reg = <5>;
            };
            channel@6 {
                reg = <6>;
            };
        };
    };
